<p align="center">
    <a target="_blank" href="https://search.maven.org/search?q=wu-lazy-cloud-network%20wu-lazy-cloud-network">
        <img src="https://img.shields.io/nexus/s/top.wu2020/wu-lazy-cloud-network?server=https%3A%2F%2Foss.sonatype.org&style=flat&logo=log" alt="Maven" />
    </a>
    <a target="_blank" href="https://search.maven.org/search?q=wu-lazy-cloud-network%20wu-lazy-cloud-network">
        <img src="https://img.shields.io/maven-central/v/top.wu2020/wu-lazy-cloud-network" alt="Maven" />
    </a>
    <a target="_blank" href="https://www.apache.org/licenses/LICENSE-2.0.txt">
		<img src="https://img.shields.io/:license-Apache2-blue.svg" alt="Apache 2" />
	</a>
    <a target="_blank" href="https://www.oracle.com/java/technologies/javase/jdk11-archive-downloads.html">
		<img src="https://img.shields.io/badge/JDK-11-green.svg" alt="jdk-11" />
	</a>
    <a target="_blank" href="https://www.oracle.com/java/technologies/javase/jdk17-archive-downloads.html">
		<img src="https://img.shields.io/badge/JDK-17-green.svg" alt="jdk-17" />
	</a>
    <br />
        <img src="https://img.shields.io/badge/SpringBoot-v3.x-blue">
    <br />
    <a target="_blank" href='https://gitee.com/wujiawei1207537021/wu-lazy-cloud-network'>
		<img src='https://gitee.com/wujiawei1207537021/wu-lazy-cloud-network/badge/star.svg' alt='Gitee star'/>
	</a>
    <a target="_blank" href='https://gitee.com/wujiawei1207537021/wu-lazy-cloud-network'>
		<img src='https://img.shields.io/github/stars/wujiawei1207537021/wu-lazy-cloud-network?style=flat&logo=github' alt='GitHub star'/>
	</a>
    <a target="_blank" href='https://gitee.com/wujiawei1207537021/wu-lazy-cloud-network'>
		<img src='https://img.shields.io/github/forks/wujiawei1207537021/wu-lazy-cloud-network?style=flat&logo=github' alt='GitHub star'/>
	</a>

</p>

#### 项目介绍

wu-lazy-cloud-network
是一款基于（[wu-framework-parent](https://gitee.com/wujiawei1207537021/wu-framework-parent)）孵化出的项目，内部使用Lazy
ORM操作数据库，使用环境JDK17 Spring Boot 3.0.2。的网络穿透、渗透工具支持Tcp、Http、Socks
主要功能：
- 服务端渗透客户端（网络穿透），对于没有公网IP的服务进行公网IP映射
- ![NetworkPermeateServerPermeateClient.png](NetworkPermeateServerPermeateClient.png)
- 服务端渗透服务端----本地同局域网内端口映射
- ![NetworkPermeateServerPermeateServer.png](NetworkPermeateServerPermeateServer.png)
- 客户端渗透服务端----本地端口映射到另一个服务端中的局域网端口
- ![NetworkPermeateClientPermeateServer.png](NetworkPermeateClientPermeateServer.png)
- 客户端渗透客户端----本地端口映射到另一个局域网端口
- ![NetworkPermeateClientPermeateClient.png](NetworkPermeateClientPermeateClient.png)
- 客户端代理服务端、客户端代理客户端、服务端代理服务端、服务端代理客户端（VPN）----异地组网搭建代理
- ![wlcn-proxy1.0-.png](wlcn-proxy1.0-.png)

[UI](https://gitee.com/wujiawei1207537021/wu-lazy-cloud-network-server-ui)

### 内网穿透

| 模块                                   | 所属层级 | 描述                           | 快照版本                                                                                                                                                                                                                                                                                                           | 发布版本                                                                                                                                                                                                                                                         |
|--------------------------------------|------|------------------------------|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| wu-lazy-cloud-heartbeat-common       | 组件   | 内网穿透公共模块（声明接口、枚举、常量、适配器、解析器） | <a target="_blank" href="https://search.maven.org/search?q=wu-lazy-cloud-heartbeat-common%20wu-bionic-parent"><img src="https://img.shields.io/nexus/s/top.wu2020/wu-bionic-parent?server=https%3A%2F%2Foss.sonatype.org&style=flat&logo=log" alt="Maven" /></a>                                               | <a target="_blank" href="https://search.maven.org/search?q=wu-lazy-cloud-heartbeat-common%20wu-lazy-cloud-heartbeat-common"><img src="https://img.shields.io/maven-central/v/top.wu2020/wu-lazy-cloud-heartbeat-common" alt="Maven" /></a>                   |
| wu-lazy-cloud-heartbeat-client       | 组件   | 客户端（支持二次开发）                  | <a target="_blank" href="https://search.maven.org/search?q=wu-lazy-cloud-heartbeat-client%20wu-lazy-cloud-heartbeat-client"><img src="https://img.shields.io/nexus/s/top.wu2020/wu-lazy-cloud-heartbeat-client?server=https%3A%2F%2Foss.sonatype.org&style=flat&logo=log" alt="Maven" /></a>                   | <a target="_blank" href="https://search.maven.org/search?q=wu-lazy-cloud-heartbeat-client%20wu-lazy-cloud-heartbeat-client"><img src="https://img.shields.io/maven-central/v/top.wu2020/wu-lazy-cloud-heartbeat-client" alt="Maven" /></a>                   |
| wu-lazy-cloud-heartbeat-server       | 组件   | 服务端（支持二次开发）                  | <a target="_blank" href="https://search.maven.org/search?q=wu-lazy-cloud-heartbeat-server%20wu-lazy-cloud-heartbeat-server"><img src="https://img.shields.io/nexus/s/top.wu2020/wu-lazy-cloud-heartbeat-server?server=https%3A%2F%2Foss.sonatype.org&style=flat&logo=log" alt="Maven" /></a>                   | <a target="_blank" href="https://search.maven.org/search?q=wu-lazy-cloud-heartbeat-server%20wu-lazy-cloud-heartbeat-server"><img src="https://img.shields.io/maven-central/v/top.wu2020/wu-lazy-cloud-heartbeat-server" alt="Maven" /></a>                   |
| wu-lazy-cloud-ui                     | ui   | 服务端页面                        |                                                                                                                                                                                                                                                                                                                |                                                                                                                                                                                                                                                              |
| wu-lazy-cloud-heartbeat-client-start | 客户端  | 客户端                          | <a target="_blank" href="https://search.maven.org/search?q=wu-lazy-cloud-heartbeat-client-start%20wu-lazy-cloud-heartbeat-client-start"><img src="https://img.shields.io/nexus/s/top.wu2020/wu-lazy-cloud-heartbeat-client-start?server=https%3A%2F%2Foss.sonatype.org&style=flat&logo=log" alt="Maven" /></a> | <a target="_blank" href="https://search.maven.org/search?q=wu-lazy-cloud-heartbeat-client-start%20wu-lazy-cloud-heartbeat-client-start"><img src="https://img.shields.io/maven-central/v/top.wu2020/wu-lazy-cloud-heartbeat-client-start" alt="Maven" /></a> |
| wu-lazy-cloud-heartbeat-server-start | 服务端  | 服务端                          | <a target="_blank" href="https://search.maven.org/search?q=wu-lazy-cloud-heartbeat-server-start%20wu-lazy-cloud-heartbeat-server-start"><img src="https://img.shields.io/nexus/s/top.wu2020/wu-lazy-cloud-heartbeat-server-start?server=https%3A%2F%2Foss.sonatype.org&style=flat&logo=log" alt="Maven" /></a> | <a target="_blank" href="https://search.maven.org/search?q=wu-lazy-cloud-heartbeat-server-start%20wu-lazy-cloud-heartbeat-server-start"><img src="https://img.shields.io/maven-central/v/top.wu2020/wu-lazy-cloud-heartbeat-server-start" alt="Maven" /></a> |

#### 项目地址

[Gitee](https://gitee.com/wujiawei1207537021/wu-lazy-cloud-network)

[GitHub](https://github.com/wujiawei1207537021/wu-lazy-cloud-network)

#### 架构图

![architecture.png](architecture.png)


##### 通过客户端与服务端建立的连接进行访客端口绑定

    上述连接会形成一个channel，我们称之为通道（本文中简单叫**心跳通道**）
    第一步 页面GUI进行新增访客端口而后将访客端口与客户端绑定（如果客户端已经启动，使用页面客户端下线触发第二步）
    第二步 客户端与访客端口绑定后使用**心跳通道** 发送客户端告诉客户端，你帮我绑定你本地真实端口
    第三步 访客访问，访客通过访客端口访问数据，此时访客通道打开截取访客发送的数据，然后将数据发送给客户真实通道，数据返回后再返回给访客通道

### 功能

    1.内网穿透
    2.服务端自主下发数据到客户端
    3.流量监控
    4.网络代理（socks、http）

### 项目结构

| 模块                                                                                                         | 版本                   | 描述                           |
|------------------------------------------------------------------------------------------------------------|----------------------|------------------------------| 
| [wu-lazy-cloud-heartbeat-common](wu-lazy-cloud-heartbeat-common)                                           | 1.3.1-JDK17-SNAPSHOT | 内网穿透公共模块（声明接口、枚举、常量、适配器、解析器） |
| [wu-lazy-cloud-heartbeat-client](wu-lazy-cloud-heartbeat-client)                                           | 1.3.1-JDK17-SNAPSHOT | 客户端（支持二次开发）                  |
| [wu-lazy-cloud-heartbeat-server](wu-lazy-cloud-heartbeat-server)                                           | 1.3.1-JDK17-SNAPSHOT | 服务端（支持二次开发）                  |
| [wu-lazy-cloud-heartbeat-client-start](wu-lazy-cloud-heartbeat-start/wu-lazy-cloud-heartbeat-server-start) | 1.3.1-JDK17-SNAPSHOT | 客户端样例                        |
| [wu-lazy-cloud-heartbeat-server-start](wu-lazy-cloud-heartbeat-start/wu-lazy-cloud-heartbeat-client-start) | 1.3.1-JDK17-SNAPSHOT | 服务端样例                        |

### 使用技术

| 框架                                                                                                                                                                          | 版本                   | 描述           |
|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------|----------------------|--------------| 
| spring-boot                                                                                                                                                                 | 3.0.7                | springboot框架 |
| [wu-framework-web](https://gitee.com/wujiawei1207537021/wu-framework-parent/tree/master/wu-framework-web)                                                                   | 1.3.1-JDK17-SNAPSHOT | web容器        |
| [Lazy -ORM](https://gitee.com/wujiawei1207537021/wu-framework-parent/tree/master/wu-inner-intergration/wu-database-parent)                                                  | 1.3.1-JDK17-SNAPSHOT | ORM          |
| mysql-connector-j                                                                                                                                                           | 8.0.33               | mysql驱动      |
| [wu-authorization-server-platform-starter](https://gitee.com/wujiawei1207537021/wu-framework-parent/tree/master/wu-smart-platform/wu-authorization-server-platform-starter) | 1.3.1-JDK17-SNAPSHOT | 用户授权体系       |

### 使用环境

    IDEA
    Mac、Windows
    JAVA >=13
    MAVEN

### 启动[install.md](install.md)

    docker启动
        
        docker run  -d -it -p 18080:18080 --name wu-lazy-cloud-heartbeat-server registry.cn-hangzhou.aliyuncs.com/wu-lazy/wu-lazy-cloud-heartbeat-server:1.3.1-JDK17-SNAPSHOT
        
        http://127.0.0.1:18080/swagger-ui/index.html

    源码启动
### 代理工具使用[Proxy.md](Proxy.md)

#### 页面操作

启动项目后打开服务端界面
![url_info.png](url_info.png)

默认账号密码：admin/admin
![login.png](login.png)

初始化项目
![init_menu.png](init_menu.png)
添加角色
![init_role.png](init_role.png)
为用户授权
![img.png](authRoe2User.png)

刷新页面
![img.png](cloud_client.png)

客户端管理（客户端会自动注册）
![img.png](cloud_client.png)

## 服务端渗透
- 服务端口池管理（服务器端需要开放的端口）
  ![server_permeate_port_pool.png](server_permeate_port_pool.png)

- 服务端渗透客户端(内网穿透)（修改后者新增需要映射的客户端）
![server_permeate_client_mapping.png](server_permeate_client_mapping.png)

- 服务端渗透服务端
![server_permeate_server_mapping.png](server_permeate_server_mapping.png)

## 客户端渗透
- 客户端渗透端口池管理
![client_permeate_port_pool.png](client_permeate_port_pool.png)

- 客户端渗透客户端
![client_permeate_client_mapping.png](client_permeate_client_mapping.png)
- 客户端渗透服务端
![client_permeate_server_mapping.png](client_permeate_server_mapping.png)

## 报表
流量管理（每个客户端使用的流量）
![img.png](flow.png)

 流量日统计报表
![clientPerDayFlow.png](clientPerDayFlow.png)

客户端近七天使用流量
![clientPortPerDayFlow.png](clientPortPerDayFlow.png)

## 路由
- 客户端路由管理
![client_route.png](client_route.png)
- 客户端虚拟路由管理
- 创建一个虚拟的不存在的IP，代理到指定的IP
![client_virtual_route.png](client_virtual_route.png)

- 服务端路由管理
![server_route.png](server_route.png)
- 服务端虚拟路由管理
- 创建一个虚拟的不存在的IP，代理到指定的IP
![server_virtual_route.png](server_virtual_route.png)